//
//  ClientController.m
//  BufferedSocket
//
//  Created by Rainer Kupke (rkupke@gmx.de) on Thu Jul 26 2001.
//  Copyright (c) 2001 Rainer Kupke.
//

// This software is provided 'as-is', without any express or implied 
// warranty. In no event will the authors be held liable for any damages 
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose, 
// including commercial applications, and to alter it and redistribute it 
// freely, subject to the following restrictions:
//
//     1. The origin of this software must not be misrepresented; you must 
//        not claim that you wrote the original software. If you use this 
//        software in a product, an acknowledgment in the product 
//        documentation (and/or about box) would be appreciated but is not 
//        required.
//
//     2. Altered source versions must be plainly marked as such, and must
//        not be misrepresented as being the original software.
//
//     3. This notice may not be removed or altered from any source 
//        distribution.
//        

#import "ClientController.h"
#import "BufferedSocket.h"

@implementation ClientController

-(id) init
{
    [super init];
    
    socket=nil;
    
    return self;
}

- (void) awakeFromNib
{
    [connectButton setEnabled: YES];
    [disconnectButton setEnabled: NO];
    [sendButton setEnabled: NO];
}

- (IBAction)connect:(id)sender
{
    NSString *server;
    int port;
    
    server=[serverAddress stringValue];
    port=[serverPort intValue];
    socket=[[BufferedSocket alloc] init];
    [socket connectToHostName: server port: port];
    
    [connectButton setEnabled: NO];
    [disconnectButton setEnabled: YES];
    [sendButton setEnabled: YES];
}

- (IBAction)disconnect:(id)sender
{
    [connectButton setEnabled: YES];
    [disconnectButton setEnabled: NO];
    [sendButton setEnabled: NO];
    [socket release];
}

- (IBAction)send:(id)sender
{
    NSString *message,*m1,*m2,*m3,*m4;
    
    m1=[message1 stringValue];
    m2=[message2 stringValue];
    m3=[message3 stringValue];
    m4=[message4 stringValue];
    message=[NSString stringWithFormat: @"%@;%@;%@;%@;;",m1,m2,m3,m4];
    
    NS_DURING
        [socket writeString: message];
    NS_HANDLER
        NSLog([NSString stringWithFormat: @"Exception in send : %@",[localException reason]]);
    NS_ENDHANDLER
}

@end
