//
//  ServerController.m
//  BufferedSocket
//
//  Created by Rainer Kupke (rkupke@gmx.de) on Thu Jul 26 2001.
//  Copyright (c) 2001 Rainer Kupke.
//

// This software is provided 'as-is', without any express or implied 
// warranty. In no event will the authors be held liable for any damages 
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose, 
// including commercial applications, and to alter it and redistribute it 
// freely, subject to the following restrictions:
//
//     1. The origin of this software must not be misrepresented; you must 
//        not claim that you wrote the original software. If you use this 
//        software in a product, an acknowledgment in the product 
//        documentation (and/or about box) would be appreciated but is not 
//        required.
//
//     2. Altered source versions must be plainly marked as such, and must
//        not be misrepresented as being the original software.
//
//     3. This notice may not be removed or altered from any source 
//        distribution.
//        

#import <Cocoa/Cocoa.h>

@class BufferedSocket;

@interface ServerController : NSObject
{
    IBOutlet NSTextField *messageReceived;
    IBOutlet NSTextField *portNumber;
    IBOutlet NSButton *startButton;
    IBOutlet NSButton *stopButton;
    
    BufferedSocket *theSocket;
}

- (IBAction)startListening:(id)sender;
- (IBAction)stopListening:(id)sender;

- (id) init;
- (void) dealloc;
- (void) awakeFromNib;

- (void) threadListen: (id) dummy;
- (void) threadCommunicate: (BufferedSocket*) sock;

@end
