/*
  NetClass is a cross platform lightweight socket and thread library.
  Copyright (C) 2000-2002 Neill Miller 
  This file is part of NetClass.
 
  NetClass is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  NetClass is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/***********************************************************************
 * description: a platform independent network class for transferring
 *   arbitrary data.
 ***********************************************************************/

#ifndef __NETCLASS_H
#define __NETCLASS_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "ncconsts.h"
#include "ncenums.h"
#include "ncdebug.h"
#include "udpdata.h"
#include "ncsocket.h"
#include "ncsocklist.h"
#include "ncthread.h"
#include "ncmutex.h"

class netClass
{
  public:
   netClass();
   ~netClass();

   /*
     win32 users MUST call initialize on startup
     before using any of the ncSocket calls.
   */
   static int initialize();

#ifdef PACKAGE
   /* returns the package name */
   static char *getPackageName() { return PACKAGE; }
#endif

#ifdef VERSION
   /* returns the version string */
   static char *getVersionString() { return VERSION; }
#endif
};



#endif // __NETCLASS_H
