// WGPL - Wave++ General Purpose Library
// Copyright (C) 1995-2000 Wave++ (Yuri D'Elia)
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
// See the AUTHORS file for more info about the authors.  See the
// ChangeLog files for a list of changes.

// WGPL: parsing delle opzioni in stile gnu / gnu long options

#ifndef __wgpl_parseopt_hpp
#  define __wgpl_parseopt_hpp

#include <iostream.h>
#include <string.h>

// struttura per la memorizzazione dell'opzione
enum parseoption_kind { parseoption_noarg,
			parseoption_requiredarg,
			parseoption_optionalarg };

enum parseoption_retval { parseoption_notset,
			  parseoption_ok,
			  parseoption_missing,
			  parseoption_missingrarg };

struct parseoption_t
{
  ~parseoption_t();
  char shortoption;
  char *longoption;
  char *description;
  parseoption_kind kind;
  int optionnum;
  parseoption_retval retval;
  char **args;
};

int parseoption(int &argc, char *argv[], parseoption_t *options);
void parseoption_swdescription(const int &param, const parseoption_t *options);
void parseoption_swdescriptions(const char *prgname, const parseoption_t *options);

#endif
