// WGPL - Wave++ General Purpose Library
// Copyright (C) 1995-2000 Wave++ (Yuri D'Elia)
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
// See the AUTHORS file for more info about the authors.  See the
// ChangeLog files for a list of changes.

// WGPL: funzioni di utilita'

#ifndef __wgpl_util_hpp
#  define __wgpl_util_hpp

#include <string.h>
#include <fstream.h>
#include <sys/stat.h>
#include <unistd.h>

void xstrncpy(char *dest, const char *src, const size_t &deststart,
	      const size_t &srcstart, const size_t &srcstop);
size_t filesize(const char *filename);
char *basename (const char *name);
bool fexist(const char *filename);
bool fisdir(const char *filename);
char *eurcksum(const char *filename, const char &bytenum,
	       const size_t &startbyte, const size_t &stopbyte);
template <class T> T swapbytes(const T &source)
{
  T retval;
  size_t Tlenght = sizeof(T);
  size_t cnt;
  for (cnt = 0; cnt < Tlenght; cnt++)
    ((char*)&retval)[Tlenght-cnt-1]=((char*)&source)[cnt];
  return retval;
}
#endif
